Author: Roland Behme Category: Backend User Interface
Updated: 2015-01-03 Due date:
PHP Version:
Complexity:
Subject: Remove language "default" from Alternative Page Language Records
Description

Just had the case that a customer created Alternative Page Language Records with language "default". Since this does not make
sense at all and I really don't know how TYPO3 deals with such records (and probably do not want to know at all), the creation of such
records should be impossible from the Backend.
I think best would be to remove the option "default" from the language dropdown in Alternative Page Language Records.

Related issues:
related to Core - Bug # 48673: Changed language overlay behaviour in TYPO3 6.* Accepted 2013-05-30

Associated revisions
Revision 84728fc0 - 2015-01-03 14:46 - Benjamin Mack

[TASK] Remove language "default" from Alternative Page Language and
hide record type when not necessary

The pages_language_overlay table has a sys_language_uid
field, but (like all other records) it is filled with "default".
However, due to the concept of two tables for translations
with pages and pages_language_overlay, the default
value does not make any sense and rather causes trouble
within the core when set to "0" / "default".

The patch removes the static entry from the language
dropdown of a pages_language_overlay record.

See also further discussion on forge.

Releases: master
Resolves: #34823
Change-Id: I258a8e2e31411779cc46005d56bc54e2a7a78b7d
Reviewed-on: http://review.typo3.org/35695
Reviewed-by: Anja Leichsenring <aleichsenring@ab-softlab.de>
Tested-by: Anja Leichsenring <aleichsenring@ab-softlab.de>
Reviewed-by: Mathias Schreiber <mathias.schreiber@wmdb.de>
Tested-by: Mathias Schreiber <mathias.schreiber@wmdb.de>
- Status changed from New to Needs Feedback

Your customer used the List module to create an Alternative Page Language record. This is just not the right tool for the job.
The page module has logic to detect which translations are already present and will only offer the missing languages.
The list module is simply an interface to manipulate all kinds of records; the list module has no knowledge about the purpose of these records.

#2 - 2012-03-16 17:43 - Roland Behme

Hmmm, you're right. The standard TYPO3 page module does not have the option to edit the language field of an Alternative Page Language record.
The site was made using TemplaVoila, so I think this issue is related to the TemplaVoila page module. I will open another ticket in the TV bugtracker,
so this one can be closed. Thanks!

#3 - 2012-03-16 21:23 - Markus Klein

@Jigal: Besides that the list module has no knowledge about the purpose, but I question the purpose of "Default" for an Alternative Page Language in
general.

#4 - 2012-03-16 21:24 - Jigal van Hemert
- File new_page_translation.png added

Both Page modules of TemplaVoilà and TYPO3 have the possibility to create translations of pages. Behind the scenes this is done by creating an
Alternative Page Language record.
The Page modules show which translations (Alternative Page Language records) are already present on the page and which website languages (the
Website Language records in the root of the installation) do not have an Alternative Page Language record on the page.
See attached image.

I still think that your customer used the List module to create extra Alternative Page Language records. This is a possible method, but the List module
doesn't have the knowledge about the function of those records. So it happily create multiple records of a certain language.

Before filing a bug report with TemplaVoilà it may be a good idea to ask your customer how they created those records and maybe teach them how to
create translations with the Page module.

#5 - 2012-03-16 21:56 - Jigal van Hemert

@Markus : it seems that an option for 'default' is not needed, but I'm not 100% sure that there won't be problems if it was removed from the TCA.

#6 - 2012-03-17 08:44 - Roland Behme

He created the page translations through the page module, but then edited the translated page properties, fiddled around with the language setting and
set the record to "default" language. So technically it's possible for an editor to create records that make no sense (either with list module or TV page
module), so I agree with Markus: maybe it should be considered to remove the "default" option from TCA if possible.
Of course then you can still create multiple Page Language records for the same language using the list module, but that is probably not a likely case
since most editors don't know about these records or have them hidden through user page TSCONFIG settings anyway.

#7 - 2012-03-18 11:43 - Oliver Hader
- Tracker changed from Bug to Feature

#8 - 2012-03-18 11:43 - Oliver Hader
- Status changed from Needs Feedback to Accepted

Alright, I've moved it to the feature tracker... looks like a topic for "simplify TYPO3"...

#9 - 2014-06-29 20:23 - Stefan Neufeind

From reading I agree that having "default" in the dropdown for an alternative language-record doesn't make sense and we might want to consider
removing that option.

#10 - 2014-12-31 17:20 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35695

#11 - 2015-01-03 12:35 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35695

#12 - 2015-01-03 12:36 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35695

#13 - 2015-01-03 12:46 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35695

#14 - 2015-01-03 12:57 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35695

#15 - 2015-01-03 13:02 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/35695
#16 - 2015-01-03 14:54 - Wouter Wolters
- Status changed from Under Review to Resolved
